function geteigm(n, diagonals)

  if any((diagonals.a3f .* diagonals.a2f) .< 0)      # check if positive
    println("Error in geteigm: Cross-diagonal product not positive")
    return true          # lfail_balloon is true
  end

  #Construct a triadiagonal matrix
  tridiag = SparseArrays.spdiagm(-1 => diagonals.a3f,
            0 => diagonals.a1f, 
            1 => diagonals.a2f)

  #Attempt to use Arnoldi method failed
  restarts = 100
  d, h = ArnoldiMethod.partialschur(tridiag, nev=1, which=LR(), restarts = restarts, tol=1e-6)
  maxtries = 3
  tries = 1
  while !h.converged && tries < maxtries
    restarts *= 10
    d, h = ArnoldiMethod.partialschur(tridiag, nev=1, which=LR(), restarts=restarts, tol=1e-6) 
    tries += 1
    #println("restarts: ",restarts)
  end
  #println("converged: ",h.converged)
  eigm = real(d.eigenvalues[1])
  
  if !h.converged
    return true, 0.0
  else
    return false, eigm
  end

end
