function getmatrix(vmecSurface::VmecSurface, s::Float64, init_zeta::Float64, init_theta::Float64, 
                   inc::Int64, xmin::Float64, h::Float64, n::Int64, tsymm::Bool,
                   coeffs_f::coeffs_struct, coeffs_h::coeffs_struct, diagonals::diagonal_struct,
                  params::BalloonParams)

  h2 = h^2;
  
  
  coeffs_f.x .= xmin .+ [0:n-1;]*h;                    # build full mesh,
  lfail_balloon = coeffs(vmecSurface, s, init_zeta, init_theta, n, coeffs_f, params);          # evaluate coefficients on full mesh
  if lfail_balloon
     return lfail_balloon
  end
  

  coeffs_h.x .= coeffs_f.x[2:n] .- h/2;                              # build half mesh,
  lfail_balloon = coeffs(vmecSurface, s, init_zeta, init_theta, n-1, coeffs_h, params);           # evaluate coefficients on half mesh
  if lfail_balloon
     return lfail_balloon
  end

  if tsymm
     diagonals.a1f[1] = (-2*coeffs_h.p[1] + coeffs_f.q[1]*h2) / (coeffs_f.r[1]*h2);  #  B.C.: F[1]=F[-1] i.e. F'(0)=0
     diagonals.a2f[1] = 2*coeffs_h.p[1]/(coeffs_f.r[1]*h2);                         #  size of matrix is THEN npts-1

     diagonals.a1f[2:n-1] .= (-coeffs_h.p[2:n-1] - coeffs_h.p[1:n-2] + coeffs_f.q[2:n-1]*h2) ./
                             (coeffs_f.r[2:n-1]*h2);                                 # build A-diagonal
     diagonals.a2f[2:n-2] .= coeffs_h.p[2:n-2] ./ (coeffs_f.r[2:n-2]*h2);           # build A-supdiagonal
     diagonals.a3f .= coeffs_h.p[1:n-2] ./ (coeffs_f.r[2:n-1]*h2);                  # build A-subdiagonal

  else                                                         #  size of matrix is npts-2
     diagonals.a1f .= (-coeffs_h.p[2:n-1] - coeffs_h.p[1:n-2] + coeffs_f.q[2:n-1]*h2) ./
                      (coeffs_f.r[2:n-1]*h2);                                        # build A-diagonal
     diagonals.a2f .= coeffs_h.p[2:n-2] ./ (coeffs_f.r[2:n-2]*h2);         # build A-supdiagonal
     diagonals.a3f .= coeffs_h.p[2:n-2] ./ (coeffs_f.r[3:n-1]*h2);         # build A-subdiagonal
  end

  return lfail_balloon
end
