using .StellaratorOptimization
using .MPI

struct _StellOptMetrics <: StellOpt.AbstractModuleWrapper end
export _StellOptMetrics

function StellOpt.evaluate_target_expression(::Union{T, Type{T}},
                                             method::Expr;
                                            ) where {T <: _StellOptMetrics}
  return eval(method)
end

function StellOpt.evaluate_target_expression(::Union{T, Type{T}},
                                             method::Expr,
                                             comm::MPI.Comm;
                                            ) where {T <: _StellOptMetrics}
  method_call = copy(method)
  mpi_slot = findlast(x -> x === :mpi, method_call)
  method_call[mpi_slot] = comm
  eval(method_call)
end
